<template>
    <div>
        <ErrorComponent :error-value="error" class="w"/>
        <SuccessComponent :success-value="success" class="w"/>
        <v-row no-gutters ref="avail-area">
            <v-col sm="12" :md="mdCanvasCols">
                <div class="fp" :style="Style">
                    <img class="max" :src="floorplan.info.image">

                    <canvas id='canvas' width="10000" height="10000" class="max">

                    </canvas>
                    <div v-for="(pos, workerId) in displayPositions" :key="workerId"
                         class="dot"
                         :style="{
                            left: pos.x + '%' , top: pos.y + '%',
                            transition: 'box-shadow 0.2s',
                            ...pos.inactive ? { border: `2px dashed ${pos.color}`, background: 'transparent' } : { background: pos.color },
                            ...highlightedWorker === workerId && { 'box-shadow': `0 0 8px 1px ${pos.color}` },
                        }"
                         @mouseover="highlightWorker(workerId)"
                         @mouseleave="highlightWorker(null)"
                    >
                        <!-- TODO: hover/click to highlight worker -->
                        <!-- <div class="name">{{pos.name}}</div> -->
                    </div>
                </div>
            </v-col>
            <v-col :md="12 - mdCanvasCols">
                <div class="ml-5" style="max-height: calc(100vh - 64px); height: 100%;">
                    <!-- TODO: when legends are needed -->
                    <v-sheet style="display: none;">
                        <div class="text-h5 text-lg-h4 font-weight-bold">Legend</div>
                        <div class="my-2">
                            <div v-for="role in [
                                    { type: 'Site Manager', color: 'red' },
                                    { type: 'Team Manager', color: 'green' },
                                    { type: 'Worker', color: 'blue'}
                                ]"
                                 :key="role.type"
                                 style="position: relative;"
                                 class="my-1"
                            >
                                <div class="dot"
                                     :style="{ background: role.color, top: '50%', transform: 'translate(0, -50%)' }"/>
                                <div class="ml-5">{{role.type}}</div>
                            </div>
                        </div>
                        <div class="body-2">Click on icon for more employee information</div>
                    </v-sheet>
                    <div class="my-4 mx-2" style="max-height: 100%;">
                        <div class="text-h5 text-lg-h4 text-center">Workers on Site</div>
                        <div class="text-center mb-4">
                            <div class="text-body-2 d-inline-block">View by
                                <v-menu>
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                                color="primary"
                                                dark
                                                v-bind="attrs"
                                                v-on="on"
                                                height="24"
                                        >
                                            {{ selectedView }}
                                            <v-icon>{{ 'mdi-chevron-down' }}</v-icon>
                                        </v-btn>
                                    </template>
                                    <v-list elevation="0">
                                        <v-list-item
                                                v-for="(view, index) in views"
                                                :key="index"
                                                @click="selectView(view)"
                                        >
                                            <v-list-item-title>{{ view.toUpperCase() }}</v-list-item-title>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </div>
                        </div>

                        <!-- v-if workers within danger zones -->
                        <div
                                class="highlight-within-danger-zones">

                        </div>

                        <!-- TODO: dynamic instead of hardcoded height -->
                        <!-- TODO: mobile-suitable height -->
                        <perfect-scrollbar :style="viewWrapperStyle">
                            <div class="zone-view" v-if="selectedView === 'Zone'">
                                <div :key="z.name" v-for="z in floorplan.info.zoneData"
                                     :style="{color: z.danger ? 'red': 'green'}">
                                    {{z.name}}
                                    <div>
                                        <v-avatar :key="workerId" v-for="workerId in workersByZone[z.name]"
                                                  size="36"
                                                  class="ma-1"
                                                  :class="{ highlight: workerId === highlightedWorker }"
                                                  :style="{
                                                transition: 'opacity 0.2s',
                                                ...displayPositions[workerId].inactive && { opacity: 0.2 } }
                                            "
                                                  @mouseover="highlightWorker(workerId)"
                                                  @mouseleave="highlightWorker(null)"
                                        >
                                            <v-img v-if="workersInfo[workerId]"
                                                   :src="workersInfo[workerId].light.image"></v-img>
                                            <div v-else
                                                 class="d-flex justify-center align-center"
                                                 :style="{ background: positions[workerId].color, color: 'white', height: '100%', width: '100%' }"
                                            >
                                                {{ positions[workerId].name | initials }}
                                            </div>
                                        </v-avatar>
                                    </div>
                                </div>
                                <!-- TODO: show-trade: boolean -->
                            </div>

                            <div class="name-view" v-if="selectedView === 'Name'">
                                <div v-for="worker in workersByName" :key="worker.id"
                                     class="pa-2 d-flex"
                                     style="line-height: 1.2; transition: opacity 0.2s;"
                                     :class="{ highlight: worker.id === highlightedWorker }"
                                     :style="{
                                        ...displayPositions[worker.id].inactive && { opacity: 0.2 }
                                    }"
                                     @mouseover="highlightWorker(worker.id)"
                                     @mouseleave="highlightWorker(null)"
                                >

                                    <v-avatar
                                            size="32"
                                            class="ma-1 align-self-center"
                                    >
                                        <v-img v-if="workersInfo[worker.id]"
                                               :src="workersInfo[worker.id].light.image"></v-img>
                                        <div v-else
                                             class="d-flex justify-center align-center"
                                             :style="{ background: positions[worker.id].color, color: 'white', height: '100%', width: '100%' }"
                                        >
                                            {{ positions[worker.id].name | initials }}
                                        </div>
                                    </v-avatar>
                                    <div class="d-inline-block ml-2">
                                        <div class="font-weight-bold">{{ worker.name }}</div>
                                        <div style="color: #616161">{{ worker.company }}</div>
                                        <div style="color: #616161">{{ worker.zone }}</div>
                                    </div>
                                </div>
                            </div>

                            <div class="company-view" v-if="selectedView === 'Company'">
                                <v-expansion-panels accordion multiple flat value="[0]">
                                    <v-expansion-panel
                                            v-for="{ company, workers } in workersByCompany"
                                            :key="company"
                                    >
                                        <v-expansion-panel-header>{{ company }}</v-expansion-panel-header>
                                        <v-expansion-panel-content>
                                            <div v-for="worker in workers" :key="worker.id"
                                                 class="pa-2 d-flex" style="line-height: 1.2;"
                                                 :class="{ highlight: worker.id === highlightedWorker }"
                                                 :style="{
                                                    transition: 'opacity 0.2s',
                                                    ...displayPositions[worker.id].inactive && { opacity: 0.2 }
                                                }"
                                                 @mouseover="highlightWorker(worker.id)"
                                                 @mouseleave="highlightWorker(null)"
                                            >

                                                <v-avatar
                                                        size="32"
                                                        class="ma-1 align-self-center"
                                                >
                                                    <v-img v-if="workersInfo[worker.id]"
                                                           :src="workersInfo[worker.id].light.image"></v-img>
                                                    <div v-else
                                                         class="d-flex justify-center align-center"
                                                         :style="{ background: positions[worker.id].color, color: 'white', height: '100%', width: '100%' }"
                                                    >
                                                        {{ positions[worker.id].name | initials }}
                                                    </div>
                                                </v-avatar>
                                                <div class="d-inline-block ml-2">
                                                    <div class="font-weight-bold">{{ worker.name }}</div>
                                                    <div style="color: #616161">{{ worker.zone }}</div>
                                                </div>
                                            </div>
                                        </v-expansion-panel-content>
                                    </v-expansion-panel>
                                </v-expansion-panels>
                            </div>
                        </perfect-scrollbar>
                    </div>
                </div>
            </v-col>
        </v-row>
    </div>
</template>

<style lang='scss' scoped>
    .dot {
        transform: translate(-50%, -50%);
        position: absolute;


        transition: left 0.2s, top 0.2s;

        .name {
            background: white;
            transform: translate(-50%, -100%);
        }

        width: 15px;
        height: 15px;
        border-radius: 50%;
        background: blue;
    }

    .fp {
        position: relative;
        margin: auto;
    }

    .max {
        display: block;
        position: absolute;
        width: 100%;
        height: 100%;
    }

    .v-list-item {
        min-height: 24px;
        max-height: 24px;
    }

    .highlight {
        opacity: 1 !important;
    }
</style>

<script lang='ts'>
    import {Component, Watch} from 'vue-property-decorator';
    import {$$, coreApi} from "../../init";
    import {Route} from "vue-router";
    import {FloorResponse} from "../../../../classLibrary/core/floorResponse";
    import {FloorPlanFullResponse} from "../../../../classLibrary/core/floorPlanFullResponse";
    import {FloorPlanFlyWeightResponse} from "../../../../classLibrary/core/floorPlanFlyWeightResponse";
    import ErrorComponent from "../../components/ErrorComponent.vue";
    import SuccessComponent from "../../components/SuccessComponent.vue";
    import {WorkerPositionResponse} from "../../../../classLibrary/core/workerPositionResponse";
    import {Drawer} from "../../../../classLibrary/Drawer";
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import {Q} from "../../../../classLibrary/Geometry/Quad";
    import {P} from "../../../../classLibrary/Geometry/Point";
    import {WorkerResponse} from '../../../../classLibrary/core/workerResponse';
    import moment from 'moment';
    import {PointFResponse} from '../../../../classLibrary/core/pointFResponse';


    @Component({
        components: {ErrorComponent, SuccessComponent},
        filters: {
            initials(name: string) {
                return name.split(' ').Map(s => s[0].toUpperCase()).join('')
            }
        }
    })
    export default class Floor extends Mixins<Validable>(Validable) {

        floorId: string = "";
        floorplanId: string = "";
        floorplan: FloorPlanFullResponse = new FloorPlanFullResponse(new FloorPlanFlyWeightResponse("", "", "", [], 0, 0,), [], []);

        positions: { [s: string]: WorkerPositionResponse } = {}
        workersInfo: { [s: string]: WorkerResponse } = {}

        workersInfoRequests: { [s: string]: Promise<any> } = {}

        async fetchWorkerInfo(workerId: string) {

            if (this.workersInfoRequests[workerId]) return
            // stores the workersInfo requests so they dont get fetched again
            const request = coreApi.Get<WorkerResponse[]>(`Worker?search=${workerId}`);
            this.workersInfoRequests[workerId] = request

            const x = await request

            if (x.Ok) {
                if (x.Ok.length !== 1) throw new Error(`Search on workerId yielded ${x.Ok.length} searches`)
                this.workersInfo[workerId] = x.Ok[0]
                delete this.workersInfoRequests[workerId]
            } else {
                this.err = x.error!;
                delete this.workersInfoRequests[workerId]
            }
        }

        inactiveDurationInSeconds: number = 300;
        currentTime = moment();
        refreshTimeInterval = 5000; // milliseconds

        get displayPositions() {
            return Object.entries(this.positions)
                .reduce((result: any, [id, truePos]) => {
                    const displayPos = {
                        x: truePos.x / this.floorplan.info.width * 100,
                        y: truePos.y / this.floorplan.info.height * 100,
                        name: truePos.name,
                        color: truePos.color,
                        time: truePos.time,
                        inactive: moment.duration(this.currentTime.diff(moment(truePos.time))).asSeconds() > this.inactiveDurationInSeconds,
                    }
                    result[id] = displayPos
                    return result
                }, {})
        }

        updateCurrentTime() {
            this.currentTime = moment();
        }


        views = [
            'Name',
            'Zone',
            'Company',
            // 'Zone & Trade' TODO: after getting trade logos
        ];
        selectedView = 'Name';

        selectView(view: string) {
            this.selectedView = view;
        }

        get withinZoneData(): { [areaId: string]: { minX: number, maxX: number, minY: number, maxY: number }[] } {
            // get minX, maxX, minY, maxY
            return this.floorplan.areas.reduce((result: any, area) => {
                result[area.areaId] = area.maps.Map(map => {
                    const items: PointFResponse[] =
                        Object.values(map)

                    const xVals = Object.values(items).Map(item => item.x)
                    const yVals = Object.values(items).Map(item => item.y)
                    const minX = Math.min(...xVals)
                    const maxX = Math.max(...xVals)
                    const minY = Math.min(...yVals)
                    const maxY = Math.max(...yVals)
                    return {minX, maxX, minY, maxY}
                })
                return result
            }, {})
        }

        withinZone({x, y}: WorkerPositionResponse) {
            for (const [areaId, zoneData] of Object.entries(this.withinZoneData)) {
                for (const map of zoneData) {
                    const {minX, maxX, minY, maxY} = map

                    if ((x >= minX && x <= maxX) && (y >= minY && y <= maxY)) {
                        return areaId
                    }
                }
            }
            throw new Error("Worker doesn't belong to a valid zone")
        }

        get workersByZone(): { [areaId: string]: string[] } {
            return Object.entries(this.positions).reduce((result: any, [id, truePos]) => {
                const zone = this.withinZone(truePos);
                if (!result[zone]) {
                    result[zone] = [];
                }
                result[zone].push(id);
                return result;
            }, {});
        }

        get workersByName(): Array<any> {
            return Object.entries(this.positions).Map(([id, truePos]) => {
                return {
                    name: truePos.name,
                    company: this.workersInfo[id] ? this.workersInfo[id].subContractor.name : null,
                    zone: this.withinZone(truePos),
                    trades: this.workersInfo[id] ? this.workersInfo[id].light.trade : [], // TODO: after trades are officially an array of strings
                    image: this.workersInfo[id] ? this.workersInfo[id].light.image : null,
                    id,
                }
            }).sort((w1, w2) => {
                return w1.name.localeCompare(w2.name)
            })
        }

        get workersByCompany() {
            const workersByCompany = Object.entries(this.positions).reduce((result: any, [id, truePos]) => {
                if (!this.workersInfo[id]) return result;
                const company = this.workersInfo[id].subContractor.name
                if (!result[company]) {
                    result[company] = [];
                }
                result[company].push({
                    name: truePos.name,
                    company: this.workersInfo[id] ? this.workersInfo[id].subContractor.name : null,
                    zone: this.withinZone(truePos),
                    trades: this.workersInfo[id] ? this.workersInfo[id].light.trade : [], // TODO: after trades are officially an array of strings
                    image: this.workersInfo[id] ? this.workersInfo[id].light.image : null,
                    id,
                });
                return result;
            }, {})

            return Object.entries(workersByCompany).Map(([company, workers]) => {
                return {company, workers}
            }).sort((c1, c2) => {
                return c1.company.localeCompare(c2.company)
            })
        }

        highlightedWorker?: string;

        highlightWorker(workerId: string) {
            this.highlightedWorker = workerId;
        }

        temp = 0;

        async init() {

            this.floorId = this.$route.params.id;
            const r = await coreApi.Get<FloorResponse>(`Floor/${this.floorId}`);
            if (!r.success) await this.$router.push("not found");
            const fp = r.Ok!.latestFloorPlan.id;
            this.floorplanId = fp;
            const fr = await coreApi.Get<FloorPlanFullResponse>(`FloorPlan/${this.floorId}/${fp}`);
            if (!fr.success) this.err = fr.error!;
            this.floorplan = fr.Ok!;
            this.temp = (0).RandomTo(1000000, true);
            this.updateStack(this.temp).then();
            setInterval(this.updateCurrentTime, this.refreshTimeInterval)
        }

        destroyed() {
            // deallocate stack
            this.temp = this.temp - 10;

        }

        async updateStack(a: number) {
            if (this.temp != a)
                return
            const x = await coreApi.Get<{ [s: string]: WorkerPositionResponse }>(`History/${this.floorId}`);
            if (x.Ok) {
                // update positions (NOTE: assuming old positions won't need to be removed)
                for (const [id, positionData] of Object.entries(x.Ok)) {
                    this.$set(this.positions, id, {
                        ...positionData,
                    })
                    if (!this.workersInfo[id]) {
                        this.fetchWorkerInfo(id)
                    }
                }
            } else {
                this.err = x.error!;
            }

            await $$(1000);
            this.updateStack(a).then();
        }

        async created() {
            await this.init();
        }

        async mountInit() {
            const c = document.getElementById("canvas") as HTMLCanvasElement;

            const ww = window.innerWidth;
            const wh = window.innerHeight;

            const w = ww / 2;
            const h = wh / 2;
            c.width = w.ToFloat();
            c.height = h.ToFloat();

            const ctx = c.getContext("2d")!;
            this.draw = new Drawer(this.floorplan.info.width, this.floorplan.info.height, w.ToFloat(), h.ToFloat(), ctx);

            const colors = this.floorplan.areas
                .Map(a => {
                        const c = (this.floorplan.info.zoneData as any)[a.areaId].color;
                        a.maps.Each(m => {
                            const q = Q(m);
                            this.draw.DrawArea(q.Quad, a.areaId, c, (this.floorplan.info.zoneData as any)[a.areaId].danger)
                        });
                        return [a.areaId, c];
                    }
                )
                .AsValue(([id, c]) => id)
                .MapValue(([k, v]) => v as string);

            const cc = Object.fromEntries(colors) as { [s: string]: string };

            this.floorplan.exits.Each(e => {
                const p1 = P(e.pt1).Point;
                const p2 = P(e.pt2).Point;

                this.draw.DrawExit([p1, p2], cc[e.area1], cc[e.area2]);
            });

            // const colors = ["blue", "green", "red", "yellow", "purple", "orange", "cyan"];
            //
            // this.floorplan.areas.Each((a, i) => {
            //     a.maps.Each(m => this.draw.DrawArea(m, a.areaId, colors[i], this.floorplan.info.zoneData.Find(z => z.name == a.areaId)!.danger))
            // })
        }

        draw: Drawer = new Drawer(0, 0, 0, 0, {} as CanvasRenderingContext2D);

        beforeDestroyed() {
            if (typeof window !== 'undefined') {
                window.removeEventListener('resize', this.onResize)
            }
        }

        async mounted() {
            this.onResize();
            await this.mountInit();
            window.addEventListener('resize', this.onResize, {passive: true})
        }

        onResize() {
            const element = this.$refs['avail-area'] as Element;
            // NOTE: using scroll height could cause unexpected behaviour later
            this.availAreaSize = {w: element.scrollWidth, h: element.scrollHeight}
        }

        availAreaSize = {w: 0, h: 0}

        mdCanvasCols = 9;

        get Style() {
            // NOTE/FUTURE: there's still a small visual glitch when opening the drawer,
            // could be 'fixed' by hardcoding NavBar's width of 256px
            const GRID_SYSTEM_COLS = 12;
            // max-ing width right now
            return this.$vuetify.breakpoint.mdAndUp ? {
                width: this.availAreaSize.w * this.mdCanvasCols / GRID_SYSTEM_COLS + 'px',
                height: this.availAreaSize.w * this.mdCanvasCols / GRID_SYSTEM_COLS / this.floorplan.info.width * this.floorplan.info.height + 'px',
            } : {
                width: this.availAreaSize.w + 'px',
                height: this.availAreaSize.w / this.floorplan.info.width * this.floorplan.info.height + 'px',
            }
        }

        get viewWrapperStyle() {
            return this.$vuetify.breakpoint.mdAndUp ? {
                height: this.$vuetify.breakpoint.height - 64 - 100 + 'px', 'overflow-y': 'auto'
            } : {
                height: 'auto'
            }
        }

        @Watch('$route', {immediate: true, deep: true})
        async onUrlChange(newVal: Route) {
            await this.init();
            await this.mountInit();
        }
    }


</script>
